#
# Conditional build:
%bcond_with	apidocs		# Sphinx based documentation
%bcond_with	system_libs	# use system modules (appdirs, jaraco.text, packaging, pyparsing...) # TODO
%bcond_with	tests		# py.test tests (few failures)
%bcond_with	bootstrap	# no system modules, bootstrap egg-info without system setuptools

%if %{with bootstrap}
%undefine	with_apidocs
%undefine	with_system_libs
%undefine	with_tests
%endif

%define		module		setuptools
%define		pypi_name	setuptools
Summary:	A collection of enhancements to the Python distutils
Summary(pl.UTF-8):	Zestaw rozszerzeń dla pythonowych distutils
Name:		python3-setuptools
Version:	65.3.0
Release:	1
Epoch:		1
License:	MIT
Group:		Development/Languages/Python
#Source0Download: https://pypi.org/simple/setuptools/
Source0:	https://github.com/pypa/setuptools/archive/v%{version}/%{pypi_name}-%{version}.tar.gz
# Source0-md5:	5f9edb9878237788e08cda599aa012c7
Patch0:		setuptools-missing.patch
Patch1:		multilib.patch
URL:		https://github.com/pypa/setuptools
%if %(locale -a | grep -q '^C\.utf8$'; echo $?)
BuildRequires:	glibc-localedb-all
%endif
BuildRequires:	python3-modules >= 1:3.7
%{!?with_bootstrap:BuildRequires:	python3-setuptools >= 1:54}
%if %{with system_libs}
# versions from pkg_resources/_vendor/vendored.txt and setuptools/_vendor/vendored.txt
BuildRequires:	python3-appdirs >= 1.4.3
BuildRequires:	python3-importlib_metadata >= 4.11.1
BuildRequires:	python3-importlib_resources >= 5.4.0
BuildRequires:	python3-jaraco.text >= 3.7.0
BuildRequires:	python3-ordered-set >= 3.1.1
BuildRequires:	python3-more_itertools >= 8.8.0
BuildRequires:	python3-packaging >= 21.3
BuildRequires:	python3-pyparsing >= 3.0.9
BuildRequires:	python3-tomli >= 2.0.1
BuildRequires:	python3-typing_extensions >= 4.0.1
BuildRequires:	python3-zipp >= 3.7.0
%endif
BuildConflicts:	python3-distribute < 0.7
%if %{with tests}
BuildRequires:	python3-Sphinx
BuildRequires:	python3-build
BuildRequires:	python3-coverage >= 4.5.1
BuildRequires:	python3-filelock >= 3.4.0
BuildRequires:	python3-flake8-2020
BuildRequires:	python3-ini2toml >= 0.9
BuildRequires:	python3-jaraco.envs >= 2.2
BuildRequires:	python3-jaraco.path >= 3.2.0
# FIXME: patch to use unittest.mock
#BuildRequires:	python3-mock
BuildRequires:	python3-paver
BuildRequires:	python3-pip >= 19.1
BuildRequires:	python3-pip_run >= 8.8
BuildRequires:	python3-pytest >= 6
BuildRequires:	python3-pytest-black >= 0.3.7
BuildRequires:	python3-pytest-checkdocs >= 2.4
BuildRequires:	python3-pytest-cov >= 2.5.1
BuildRequires:	python3-pytest-enabler >= 1.3
BuildRequires:	python3-pytest-flake8
BuildRequires:	python3-pytest-flake8-2020
BuildRequires:	python3-pytest-mypy >= 0.9.1
BuildRequires:	python3-pytest-perf
BuildRequires:	python3-pytest-xdist
BuildRequires:	python3-virtualenv >= 13.0.0
BuildRequires:	python3-tomli
BuildRequires:	python3-tomli-w >= 1.0.0
BuildRequires:	python3-wheel
%endif
%if %{with apidocs}
BuildRequires:	python3-Sphinx
BuildRequires:	python3-furo
BuildRequires:	python3-jaraco
BuildRequires:	python3-jaraco.packaging >= 9
BuildRequires:	python3-jaraco.tidelift >= 1.4
BuildRequires:	python3-pygments-github-lexers >= 0.0.5
BuildRequires:	python3-rst.linker >= 1.9
# specified but not required(?)
#BuildRequires:	python3-pygments-github-lexers >= 0.0.5
BuildRequires:	python3-setuptools >= 1:34
BuildRequires:	python3-sphinx-hoverxref
BuildRequires:	python3-sphinx-notfound-page >= 0.8.3
BuildRequires:	python3-sphinx-reredirects
BuildRequires:	python3-sphinx_favicon
BuildRequires:	python3-sphinx_inline_tabs
BuildRequires:	python3-sphinxcontrib-towncrier
BuildRequires:	python3-toml
%endif
%{!?with_bootstrap:BuildRequires:	rpm-pythonprov}
BuildRequires:	rpmbuild(macros) >= 1.714
BuildRequires:	unzip
BuildConflicts:	python3-setuptools_scm
Requires:	python3-modules >= 1:3.7
%if %{with system_libs}
# versions from pkg_resources/_vendor/vendored.txt and setuptools/_vendor/vendored.txt
Requires:	python3-appdirs >= 1.4.3
Requires:	python3-importlib_metadata >= 4.11.1
Requires:	python3-importlib_resources >= 5.4.0
Requires:	python3-jaraco.text >= 3.7.0
Requires:	python3-ordered-set >= 3.1.1
Requires:	python3-more_itertools >= 8.8.0
Requires:	python3-packaging >= 21.3
Requires:	python3-pyparsing >= 3.0.9
Requires:	python3-tomli >= 2.0.1
Requires:	python3-typing_extensions >= 4.0.1
Requires:	python3-zipp >= 3.7.0
%endif
BuildArch:	noarch
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%description
setuptools is a collection of enhancements to the Python distutils
that allow you to more easily build and distribute Python 2.x
packages, especially ones that have dependencies on other packages.

%description -l pl.UTF-8
setuptools to zestaw rozszerzeń do pythonowych distutils umożliwiający
łatwiejsze budowanie i rozprowadzanie pakietów Pythona 2.x,
szczególnie tych mających zależności od innych pakietów.

Ten pakiet zawiera składniki uruchomieniowe setuptools, potrzebne do
uruchamiania kodu wymagającego pkg_resources.py, przeznaczone dla
Pythona 2.x.

%package apidocs
Summary:	%{module} API documentation
Summary(pl.UTF-8):	Dokumentacja API %{module}
Group:		Documentation

%description apidocs
API documentation for %{module}.

%description apidocs -l pl.UTF-8
Dokumentacja API %{module}.

%prep
%setup -q -n %{module}-%{version}
%patch0 -p1
%patch1 -p1

%if %{with system_libs}
exit 1 # TODO: unvendor modules from pkg_resources/_vendor
%endif

%build
%if %{with bootstrap}
%{__python3} setup.py egg_info
%endif

LC_ALL=C.UTF-8 \
%py3_build

%{?with_tests:%{__python3} -m pytest pkg_resources/tests setuptools/tests tests}

%if %{with apidocs}
cd docs
%{__python3} -m sphinx -W . build/html
%endif

%install
rm -rf $RPM_BUILD_ROOT

%py3_install

%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(644,root,root,755)
%doc CHANGES.rst LICENSE README.rst
%{py3_sitescriptdir}/_distutils_hack
%{py3_sitescriptdir}/distutils-precedence.pth
%{py3_sitescriptdir}/pkg_resources
%{py3_sitescriptdir}/setuptools
%{py3_sitescriptdir}/%{module}-%{version}*py*.egg-info

%if %{with apidocs}
%files apidocs
%defattr(644,root,root,755)
%doc docs/build/html/{_static,deprecated,development,references,userguide,*.html,*.js}
%endif
%changelog
* Thu Sep 15 2022 PLD Linux Team <feedback@pld-linux.org>
- For complete changelog see: http://git.pld-linux.org/?p=packages/python3-setuptools.git;a=log;h=master

* Thu Sep 01 2022 Jakub Bogusz <qboosh@pld-linux.org> 2f5fae8
- updated to 65.3.0, usable bootstrap bcond

* Tue Apr 26 2022 Jan Rękorajski <baggins@pld-linux.org> 8022507
- keep purelib in sync with python3 package to properly support multilib installs, rel 2

* Sat Apr 09 2022 Jan Rękorajski <baggins@pld-linux.org> 1d7f618
- rel 1

* Sat Apr 09 2022 Jan Rękorajski <baggins@pld-linux.org> 3192842
- BC python3-setuptools_scm, pypi source is broken (missing doc files), we need to use git

* Sat Apr 09 2022 Jan Rękorajski <baggins@pld-linux.org> a57a3e1
- up to 62.0.0

* Fri Apr 08 2022 Jan Rękorajski <baggins@pld-linux.org> 300f73b
- apidocs need network fro sphinx build, disabled, rel 3

* Thu Mar 31 2022 Jan Rękorajski <baggins@pld-linux.org> 69c5873
- neeeds wheel to build docs

* Thu Mar 31 2022 Jan Rękorajski <baggins@pld-linux.org> ad55026
- rel 2 again

* Wed Mar 30 2022 Jan Rękorajski <baggins@pld-linux.org> 08eb91f
- rebuild with tests and docs

* Sat Mar 26 2022 Jan Rękorajski <baggins@pld-linux.org> a4f7ab3
- rel 1.2 for second bootstrap to let rpm generate provides deps

* Sat Mar 26 2022 Jan Rękorajski <baggins@pld-linux.org> 17f2be7
- rel 2

* Fri Mar 25 2022 Jan Rękorajski <baggins@pld-linux.org> 01c5703
- rebuild with python 3.10

* Fri Mar 25 2022 Jan Rękorajski <baggins@pld-linux.org> 90582f9
- rel 1.1 for bootstrapping on python 3.10

* Fri Mar 25 2022 Jan Rękorajski <baggins@pld-linux.org> 20a0801
- fix bcond for rpm-pythonprov

* Fri Mar 25 2022 Jan Rękorajski <baggins@pld-linux.org> d975e9d
- do not require rpm-pythonprov when bootstrapping due to circular dep

* Thu Dec 16 2021 Jakub Bogusz <qboosh@pld-linux.org> 828f076
- added missing patch (docs template file missing in sdist)
- updated dependencies
- build docs without tox wrapper and network-based venv creation

* Thu Apr 08 2021 Arkadiusz Miśkiewicz <arekm@maven.pl> 6a8a63e
- up to 54.2.0; builds without apidocs; easy_install gone upstream

* Thu Apr 08 2021 Arkadiusz Miśkiewicz <arekm@maven.pl> 3467658
- Python3 version as separate spec.

* Sat Feb 27 2021 Jan Rękorajski <baggins@pld-linux.org> b43a791
- release 5 (by relup.sh)

* Fri Feb 26 2021 Arkadiusz Miśkiewicz <arekm@maven.pl> 1633eef
- release 4 (by relup.sh)

